import loadScript from "./load-script";
import type Vue from "vue";

function isValidVue(v: typeof Vue) {
  return (
    typeof v === "object" && v.version[0] === "3" && !!v.compile && !!v.Teleport
  );
}

export default function () {
  return new Promise<typeof Vue>((resolve) => {
    if (window.$HFC_VUE) {
      resolve(window.$HFC_VUE);
      return;
    }

    if (isValidVue(window.Vue)) {
      window.$HFC_VUE = window.Vue;
      resolve(window.$HFC_VUE);
      return;
    }

    loadScript(
      window.$HFC_CDN_URL + "/@hyper-function/vue@3.2.6/dist/vue.js"
    ).then(() => {
      resolve(window.$HFC_VUE);
    });
  });
}
